package Local.Game.HUD
{
   import Local.*;
   import Local.Game.Level.*;
   import Local.Game.Thing.*;
   import Local.Game.World.*;
   import Local.Game.World.Map.*;
   import Local.Game.World.Map.Cell.*;
   import STC9.IO.*;
   import STC9.System.*;
   import flash.display.*;
   import flash.events.*;
   import flash.filters.*;
   import flash.geom.*;
   import flash.text.*;
   
   public class CHUDData
   {
      
      public static const SECONDS:int;
      
      {
         if(true)
         {
            SECONDS = CThingBase.SECONDS;
         }
      }
      
      private var mHUD:CHUD;
      
      public function CHUDData(param1:CHUD)
      {
         super();
         mHUD = param1;
      }
      
      public function e_RDCOMPLETE_CLUSTER(param1:Event = null) : void
      {
         ActivateRDIcon(CHUDIcon(param1.currentTarget),"strikes",["clusterbomb"]);
      }
      
      public function InitPanel_Upgrades(param1:CHUDPanel) : void
      {
         var _loc2_:CHUDIcon = null;
         param1.AddIcon(_loc2_ = new CHUDIcon("rdtomahawk",new Icon_RD_Tomahawk(),"rd",true,5 * SECONDS,1,100000));
         if(true)
         {
            _loc2_.mDesc_Normal = "Click to add the Tomahawk Missile to your arsenal. Good for precision on ground targets. (CTRL-Click to cancel)";
            _loc2_.addEventListener(CHUDIcon.RDCOMPLETE,e_RDCOMPLETE_TOMAHAWK);
         }
         param1.AddIcon(_loc2_ = new CHUDIcon("rdpatriot",new Icon_RD_Patriot(),"rd",true,5 * SECONDS,1,150000));
         if(true)
         {
            _loc2_.mDesc_Normal = "Click to add the Patriot Missile to your arsenal. Good for precision on airbourne targets. (CTRL-Click to cancel)";
            _loc2_.addEventListener(CHUDIcon.RDCOMPLETE,e_RDCOMPLETE_PATRIOT);
         }
         param1.AddIcon(_loc2_ = new CHUDIcon("rdtankm1a1",new Icon_RD_TankM1A1(),"rd",true,5 * SECONDS,1,200000));
         if(true)
         {
            _loc2_.mDesc_Normal = "Click to add the M1A1 Abrams Battle tank to your arsenal. Good for defensive front lines. (CTRL-Click to cancel)";
            _loc2_.addEventListener(CHUDIcon.RDCOMPLETE,e_RDCOMPLETE_TANKM1A1);
         }
         param1.AddIcon(_loc2_ = new CHUDIcon("rdartillery",new Icon_RD_Artillery(),"rd",true,10 * SECONDS,1,250000));
         _loc2_.mDesc_Normal = "Click to add the Artillery strike to your arsenal. Great for stopping the enemy progressing beyond a ground location. (CTRL-Click to cancel)";
         _loc2_.addEventListener(CHUDIcon.RDCOMPLETE,e_RDCOMPLETE_ARTILLERY);
         param1.AddIcon(_loc2_ = new CHUDIcon("rdapache",new Icon_RD_Apache(),"rd",true,10 * SECONDS,1,500000));
         _loc2_.mDesc_Normal = "Click to add the Apache Attack Helicopter to your arsenal. Great for stopping the enemy progressing beyond an air/ground location. (CTRL-Click to cancel)";
         _loc2_.addEventListener(CHUDIcon.RDCOMPLETE,e_RDCOMPLETE_APACHE);
         param1.AddIcon(_loc2_ = new CHUDIcon("rdchinook",new Icon_RD_Chinook(),"rd",true,10 * SECONDS,1,700000));
         if(true)
         {
            _loc2_.mDesc_Normal = "Click to add the Chinook Transport Helicopter to your arsenal. Great for bringing Tanks and Troops to the front line. (CTRL-Click to cancel)";
            _loc2_.addEventListener(CHUDIcon.RDCOMPLETE,e_RDCOMPLETE_CHINOOK);
         }
         param1.AddIcon(_loc2_ = new CHUDIcon("rdcluster",new Icon_RD_ClusterBomb(),"rd",true,10 * SECONDS,1,1000000));
         if(true)
         {
            _loc2_.mDesc_Normal = "Click to add the Cluster Bomb strike to your arsenal. Great for removing enemies in the line of progression. (CTRL-Click to cancel)";
            _loc2_.addEventListener(CHUDIcon.RDCOMPLETE,e_RDCOMPLETE_CLUSTER);
         }
         param1.AddIcon(_loc2_ = new CHUDIcon("rdairbomb",new Icon_RD_AirBomb(),"rd",true,10 * SECONDS,1,2000000));
         _loc2_.mDesc_Normal = "Click to add the Air Bomb strike to your arsenal. Removes all Air/Ground enemy units from any location on the Battlefield. (CTRL-Click to cancel)";
         _loc2_.addEventListener(CHUDIcon.RDCOMPLETE,e_RDCOMPLETE_AIRBOMB);
      }
      
      public function InitPanel_Units(param1:CHUDPanel) : void
      {
         var _loc2_:CHUDIcon = null;
         param1.AddIcon(_loc2_ = new CHUDIcon("m16",new Icon_M16(),"spawn",true,1 * SECONDS,9,1000));
         if(true)
         {
            _loc2_.mDesc_Normal = "Click to build a Special ops troop. Highly trained and willing to die to win the war. (CTRL-Click to cancel)";
         }
         param1.AddIcon(_loc2_ = new CHUDIcon("tankm1a1",new Icon_TankM1A1(),"spawn",false,4 * SECONDS,9,10000));
         if(true)
         {
            _loc2_.mDesc_Normal = "Click to build a M1A1 Abrams Battle tank. Good at creating defensive lines and stopping the enemy\'s progression. (CTRL-Click to cancel)";
         }
         param1.AddIcon(_loc2_ = new CHUDIcon("apache",new Icon_Apache(),"spawn",false,7 * SECONDS,9,25000));
         _loc2_.mDesc_Normal = "Click to build an Apache Attack Helicopter. Great at targetting ground and air units. (CTRL-Click to cancel)";
         param1.AddIcon(_loc2_ = new CHUDIcon("chinooktroop",new Icon_ChinookTroop(),"spawn",false,8 * SECONDS,9,20000));
         _loc2_.mDesc_Normal = "Click to build a Chinook Transport Helicopter and bring troops to a precise location on the battlefield. (CTRL-Click to cancel)";
         param1.AddIcon(_loc2_ = new CHUDIcon("chinooktank",new Icon_ChinookTank(),"spawn",false,6 * SECONDS,9,20000));
         _loc2_.mDesc_Normal = "Click to build a Chinook Transport Helicopter and bring a tank to a precise location on the battlefield. (CTRL-Click to cancel)";
      }
      
      public function e_RDCOMPLETE_PATRIOT(param1:Event = null) : void
      {
         ActivateRDIcon(CHUDIcon(param1.currentTarget),"strikes",["patriotmissile"]);
      }
      
      public function e_RDCOMPLETE_APACHE(param1:Event = null) : void
      {
         ActivateRDIcon(CHUDIcon(param1.currentTarget),"units",["apache"]);
      }
      
      public function InitPanel_Map(param1:CHUDPanel) : void
      {
      }
      
      public function e_RDCOMPLETE_ARTILLERY(param1:Event = null) : void
      {
         if(true)
         {
            ActivateRDIcon(CHUDIcon(param1.currentTarget),"strikes",["artillery"]);
         }
      }
      
      public function e_LAUNCH_PATRIOT(param1:Event = null) : void
      {
         var _loc2_:CHUD = null;
         var _loc3_:CThingMain = null;
         _loc2_ = CHUDIcon(param1.currentTarget).mHUD;
         _loc2_.mLevel.AddFriend(_loc3_ = new CShotPatriot(new CPosition(0,0)));
      }
      
      public function e_LAUNCH_TOMAHAWK(param1:Event = null) : void
      {
         var _loc2_:CHUD = null;
         var _loc3_:CThingMain = null;
         _loc2_ = CHUDIcon(param1.currentTarget).mHUD;
         §§push(_loc2_.mLevel);
         §§push(§§findproperty(CShotTomahawk));
         §§push(new CPosition(0,0));
         §§push(_loc2_.mMouse);
         if(true)
         {
            §§pop().AddFriend(_loc3_ = new §§pop().CShotTomahawk(§§pop(),!!§§pop().mClickThing ? _loc2_.mMouse.mClickThing : _loc2_.mMouse.mClickPosition),0,false);
            if(true)
            {
               §§push(_loc2_.mMouse);
               if(true)
               {
                  §§goto(addr89);
               }
               §§pop().mClickThing.SelectionFlash_Init();
            }
            addr89:
            if(§§pop().mClickThing)
            {
               if(true)
               {
                  _loc2_.AddTarget(_loc2_.mMouse.mClickThing,_loc3_);
               }
               §§push(_loc2_.mMouse);
            }
            return;
         }
         §§goto(addr50);
      }
      
      public function e_LAUNCH_CLUSTERBOMB(param1:Event = null) : void
      {
         var _loc2_:CHUD = null;
         var _loc3_:CThingMain = null;
         _loc2_ = CHUDIcon(param1.currentTarget).mHUD;
         §§push(_loc2_.mLevel);
         §§push(§§findproperty(CStrikeClusterBomb));
         §§push(_loc2_.mMouse);
         if(true)
         {
            §§pop().AddFriend(_loc3_ = new §§pop().CStrikeClusterBomb(!!§§pop().mClickThing ? _loc2_.mMouse.mClickThing : _loc2_.mMouse.mClickPosition),0,false);
            if(true)
            {
               §§push(_loc2_.mMouse);
               if(true)
               {
                  §§goto(addr85);
               }
               §§pop().mClickThing.SelectionFlash_Init();
            }
            addr85:
            if(§§pop().mClickThing)
            {
               if(true)
               {
                  _loc2_.AddTarget(_loc2_.mMouse.mClickThing,_loc3_);
               }
               §§push(_loc2_.mMouse);
            }
            return;
         }
         §§goto(addr46);
      }
      
      public function e_RDCOMPLETE_AIRBOMB(param1:Event = null) : void
      {
         if(true)
         {
            ActivateRDIcon(CHUDIcon(param1.currentTarget),"strikes",["airbomb"]);
         }
      }
      
      public function InitPanel_Strikes(param1:CHUDPanel) : void
      {
         var _loc2_:CHUDIcon = null;
         param1.AddIcon(_loc2_ = new CHUDIcon("tomahawkmissile",new Icon_TomahawkMissile(),"launch",false,2 * SECONDS,1,20000,"strikeLG"));
         _loc2_.addEventListener(CHUDIcon.LAUNCH,e_LAUNCH_TOMAHAWK);
         _loc2_.mDesc_Normal = "Click to build the Tomahawk missile. This missile will lock on to all Ground targets. (CTRL-Click to cancel)";
         _loc2_.mDesc_Launch = "The Tomahawk missile is ready to launch, click to allow target allocation.";
         _loc2_.mDesc_LaunchSelected = "Either click on a ground target or launch to a location on the battlefield. (ESC to cancel)";
         param1.AddIcon(_loc2_ = new CHUDIcon("patriotmissile",new Icon_PatriotMissile(),"launch",false,2 * SECONDS,1,30000,"strikeLA"));
         _loc2_.addEventListener(CHUDIcon.LAUNCH,e_LAUNCH_PATRIOT);
         _loc2_.mDesc_Normal = "Click to build the Patriot missile. This missile will lock on to all Airbourne targets. (CTRL-Click to cancel)";
         _loc2_.mDesc_Launch = "The Patriot missile is ready to launch, click to allow target allocation.";
         _loc2_.mDesc_LaunchSelected = "No need to select a target as the Patriot will find and hunt down the closest Aribourne target. (ESC to cancel)";
         param1.AddIcon(_loc2_ = new CHUDIcon("artillery",new Icon_Artillery(),"launch",false,5 * SECONDS,1,100000,"strikeLG"));
         _loc2_.addEventListener(CHUDIcon.LAUNCH,e_LAUNCH_ARTILLERY);
         _loc2_.mDesc_Normal = "Click to order an Artillery strike. Battleships are waiting by to launch a precision strike. (CTRL-Click to cancel)";
         _loc2_.mDesc_Launch = "The Artillery strike is now ready to launch, click to allow target allocation.";
         _loc2_.mDesc_LaunchSelected = "Either click on a ground target or launch to a location on the battlefield. (ESC to cancel)";
         param1.AddIcon(_loc2_ = new CHUDIcon("clusterbomb",new Icon_ClusterBomb(),"launch",false,10 * SECONDS,1,250000,"strikeLG"));
         _loc2_.addEventListener(CHUDIcon.LAUNCH,e_LAUNCH_CLUSTERBOMB);
         _loc2_.mDesc_Normal = "Click to order a Cluster Bomb strike. An F-15 Eagle is standing by to clear an area on the battlefield. (CTRL-Click to cancel)";
         _loc2_.mDesc_Launch = "The F-15 Eagle is now airbourne and ready to strike, click to allow target allocation.";
         _loc2_.mDesc_LaunchSelected = "Either click on a ground target or launch to a location on the battlefield. (ESC to cancel)";
         param1.AddIcon(_loc2_ = new CHUDIcon("airbomb",new Icon_AirBomb(),"launch",false,20 * SECONDS,1,500000,"strikeLG"));
         if(true)
         {
            _loc2_.addEventListener(CHUDIcon.LAUNCH,e_LAUNCH_AIRBOMB);
            if(true)
            {
               _loc2_.mDesc_Normal = "Click to order an Airbomb. B-2 Stealth bombers are standing by to devastate the enemy. (CTRL-Click to cancel)";
               _loc2_.mDesc_Launch = "B-2 Stealth bombers are now airbourne and ready to strike, click to allow target allocation.";
            }
            _loc2_.mDesc_LaunchSelected = "Either click on a ground target or launch to a location on the battlefield. (ESC to cancel)";
         }
      }
      
      public function e_RDCOMPLETE_TANKM1A1(param1:Event = null) : void
      {
         if(true)
         {
            ActivateRDIcon(CHUDIcon(param1.currentTarget),"units",["tankm1a1"]);
         }
      }
      
      public function e_LAUNCH_AIRBOMB(param1:Event = null) : void
      {
         var _loc2_:CHUD = null;
         var _loc3_:CThingMain = null;
         _loc2_ = CHUDIcon(param1.currentTarget).mHUD;
         _loc2_.mLevel.AddFriend(_loc3_ = new CStrikeAirBomb(!!_loc2_.mMouse.mClickThing ? _loc2_.mMouse.mClickThing : _loc2_.mMouse.mClickPosition),0,false);
         if(_loc2_.mMouse.mClickThing)
         {
            _loc2_.AddTarget(_loc2_.mMouse.mClickThing,_loc3_);
            _loc2_.mMouse.mClickThing.SelectionFlash_Init();
         }
      }
      
      public function e_LAUNCH_ARTILLERY(param1:Event = null) : void
      {
         var _loc2_:CHUD = null;
         var _loc3_:CThingMain = null;
         _loc2_ = CHUDIcon(param1.currentTarget).mHUD;
         _loc2_.mLevel.AddFriend(_loc3_ = new CStrikeArtillery(!!_loc2_.mMouse.mClickThing ? _loc2_.mMouse.mClickThing : _loc2_.mMouse.mClickPosition),0,false);
         if(true)
         {
            if(_loc2_.mMouse.mClickThing)
            {
               if(true)
               {
                  _loc2_.AddTarget(_loc2_.mMouse.mClickThing,_loc3_);
               }
               _loc2_.mMouse.mClickThing.SelectionFlash_Init();
            }
         }
      }
      
      public function InitPanel_Unit(param1:CHUDPanel) : void
      {
      }
      
      public function e_RDCOMPLETE_TOMAHAWK(param1:Event = null) : void
      {
         ActivateRDIcon(CHUDIcon(param1.currentTarget),"strikes",["tomahawkmissile"]);
      }
      
      private function ActivateRDIcon(param1:CHUDIcon, param2:String, param3:Array) : void
      {
         var _loc4_:CHUD = null;
         var _loc5_:String = null;
         _loc4_ = param1.mHUD;
         for each(_loc5_ in param3)
         {
            if(true)
            {
               _loc4_.GetPanel(param2).GetIcon(_loc5_).MakeAvailable();
            }
         }
         if(true)
         {
            param1.Dispose();
         }
      }
      
      public function e_RDCOMPLETE_CHINOOK(param1:Event = null) : void
      {
         ActivateRDIcon(CHUDIcon(param1.currentTarget),"units",["chinooktroop","chinooktank"]);
      }
   }
}
